/*
 * Created on 03.11.2005
 */
package minimizer_components;

import java.awt.Graphics;

/**
 * @author ORKObv
 * @version
 */
public class And {
    
    private String andString = "&";
    private int length = 30;
    private int height = 40;
    private final int VAR_COUNT = 4;
    private final int VAR_DISTANCE = height / (VAR_COUNT + 1);
    private int pos_x;
    private int pos_y;
    
    //Hilfsvariable zum zeichnen der Linien von OR zu den ANDs:
    private int pos_y_neu;
    
    //STATISCH!!!
    private boolean a = false;
    private boolean b = false;
    private boolean c = false;
    private boolean d = false;
    
    private boolean a_minus = false;
    private boolean b_minus = false;
    private boolean c_minus = false;
    private boolean d_minus = false;
    
    /**
     * Erzeugen des Und-Objektes. x und y ist wichtig fuer das zeichnen.
     * @param position_x x-position der liken oberen Rechteck-Ecke
     * @param position_y y-position der liken oberen Rechteck-Ecke
     */
    public And(int position_x, int position_y, boolean a, boolean b, boolean c, boolean d) {
        
        this.pos_x = position_x;
        this.pos_y = position_y;
        
        //STATISCH!!!
        this.a = a;
        this.b = b;
        this.c = c;
        this.d = d;
    }
    
    /***/
    
    public void drawAnd(Graphics g, boolean drawLines) {
        
        //Zeichnen des Rechtecks:
        g.drawLine(pos_x, pos_y, pos_x + length, pos_y); // oben
        g.drawLine(pos_x, pos_y, pos_x, pos_y + height); // links
        g.drawLine(pos_x + length, pos_y, pos_x + length, pos_y + height); // rechts
        g.drawLine(pos_x, pos_y + height, pos_x + length, pos_y + height); // unten
        
        //Zeichnen der Striche zu den einzelnen Variablen (STATISCH!!!):
        if (drawLines) {
        	
	        int var_distance_position = 0;
	        int point_pos = 0;
	        
	    	var_distance_position += VAR_DISTANCE;
	    	if (this.a) {
	    		
	    		point_pos = 20;
	    		g.drawLine(pos_x, pos_y + var_distance_position+3, point_pos+3, pos_y + var_distance_position+3);
	    		g.fillOval(point_pos, pos_y + var_distance_position, 6, 6);
	    		
	    		if (a_minus)
	    			g.drawOval(pos_x, pos_y + var_distance_position, 6, 6);
	    	}
	    	
	    	var_distance_position += VAR_DISTANCE;
	    	if (this.b) {
	    		
	    		point_pos = 35;
	    		g.drawLine(pos_x, pos_y + var_distance_position+3, point_pos+3, pos_y + var_distance_position+3);
	    		g.fillOval(point_pos, pos_y + var_distance_position, 6, 6);
	    		
	    		if (b_minus)
	    			g.drawOval(pos_x, pos_y + var_distance_position, 6, 6);
	    	}
	    	
	    	var_distance_position += VAR_DISTANCE;
	    	if (this.c) {
	    		
	    		point_pos = 50;
	    		g.drawLine(pos_x, pos_y + var_distance_position+3, point_pos+3, pos_y + var_distance_position+3);
	    		g.fillOval(point_pos, pos_y + var_distance_position, 6, 6);
	    		
	    		if (c_minus)
	    			g.drawOval(pos_x, pos_y + var_distance_position, 6, 6);
	    	}
	    	
	    	var_distance_position += VAR_DISTANCE;
	    	if (this.d) {
	    		
	    		point_pos = 65;
	    		g.drawLine(pos_x, pos_y + var_distance_position+3, point_pos+3, pos_y + var_distance_position+3);
	    		g.fillOval(point_pos, pos_y + var_distance_position, 6, 6);
	    		
	    		if (d_minus)
	    			g.drawOval(pos_x, pos_y + var_distance_position, 6, 6);
	    	}
        }
        
        //Zeichnen des Strings in dem Rechteck:
        g.drawString(andString, (pos_x + length) - 15, pos_y + 15);
    }
    
    public void drawAnd(Graphics g, int posi_x, int posi_y) {
    	
    	this.pos_y_neu = posi_y;
        
        //Zeichnen des Rechtecks:
        g.drawLine(posi_x, posi_y, posi_x + length, posi_y);
        g.drawLine(posi_x, posi_y, posi_x, posi_y + height);
        g.drawLine(posi_x + length, posi_y, posi_x + length, posi_y + height);
        g.drawLine(posi_x, posi_y + height, posi_x + length, posi_y + height);
        
        //Zeichnen der Striche zu den einzelnen Variablen (STATISCH!!!):
        int var_distance_position = 0;
        int point_pos = 0;
        
    	var_distance_position += VAR_DISTANCE;
    	if (this.a) {
    		
    		point_pos = 20;
    		g.drawLine(posi_x, posi_y + var_distance_position+3, point_pos+3, posi_y + var_distance_position+3);
    		g.fillOval(point_pos, posi_y + var_distance_position, 6, 6);
    		
    		if (a_minus)
    			g.drawOval(posi_x, posi_y + var_distance_position, 6, 6);
    	}
    	
    	var_distance_position += VAR_DISTANCE;
    	if (this.b) {
    		
    		point_pos = 35;
    		g.drawLine(posi_x, posi_y + var_distance_position+3, point_pos+3, posi_y + var_distance_position+3);
    		g.fillOval(point_pos, posi_y + var_distance_position, 6, 6);
    		
    		if (b_minus)
    			g.drawOval(posi_x, posi_y + var_distance_position, 6, 6);
    	}
    	
    	var_distance_position += VAR_DISTANCE;
    	if (this.c) {
    		
    		point_pos = 50;
    		g.drawLine(posi_x, posi_y + var_distance_position+3, point_pos+3, posi_y + var_distance_position+3);
    		g.fillOval(point_pos, posi_y + var_distance_position, 6, 6);
    		
    		if (c_minus)
    			g.drawOval(posi_x, posi_y + var_distance_position, 6, 6);
    	}
    	
    	var_distance_position += VAR_DISTANCE;
    	if (this.d) {
    		
    		point_pos = 65;
    		g.drawLine(posi_x, posi_y + var_distance_position+3, point_pos+3, posi_y + var_distance_position+3);
    		g.fillOval(point_pos, posi_y + var_distance_position, 6, 6);
    		
    		if (d_minus)
    			g.drawOval(posi_x, posi_y + var_distance_position, 6, 6);
    	}
        
        //Zeichnen des Strings in dem Rechteck:
        g.drawString(andString, (posi_x + length) - 15, posi_y + 15);
    }
    
    /* getter */
    
    public int getLength() {
        return this.length;
    }
    
    public int getHeight() {
        return this.height;
    }
    
    public int getX() {
        return this.pos_x;
    }
    
    public int getY() {
        return this.pos_y;
    }
    
    public int getNewY() {
    	return this.pos_y_neu;
    }
    
    /* setter */
    
    public void setABCD (boolean a, boolean b, boolean c, boolean d,
    		boolean a_minus, boolean b_minus, boolean c_minus, boolean d_minus) {
    	
    	this.a = a; this.a_minus = a_minus;
    	this.b = b; this.b_minus = b_minus;
    	this.c = c; this.c_minus = c_minus;
    	this.d = d; this.d_minus = d_minus;
    }
}
