package minimizer_components;

/*
 * Created on 27.01.2006
 */

/**
 * @author orko
 */

import java.util.ArrayList;

import minimizer_gui.MinimizerPanelFrame;
import minimizer_gui.MinimizerTextfieldPanel;

public class MinimizeITKV {
	
	private int COUNT_VAR;
	private int REIHEN;
	private int SPALTEN;
	
	private ArrayList functionList;
	private ArrayList nichtKlammernList;
	private ArrayList preparedFunctionList;
	private ArrayList preparedFunctionList2;
	
	private String kvDiagrammVars[][];
	private int kvDiagrammMarked[][];
	
	private ArrayList stringFunctionList;
	
//	private ArrayList endMiniList;
	private static ArrayList ENDMINIList;
	
	/**
	 * Erzeugt ein MinimizeITKV-Objekt mit der Information
	 * um wieviele Variablen es sich handelt.
	 * @param count_var
	 */
	public MinimizeITKV(int count_var) {
		
		this.functionList = MinimizerTextfieldPanel.getTheOuputFunctionList();
		this.nichtKlammernList = MinimizerTextfieldPanel.getNichtKlammernList();
		this.preparedFunctionList = new ArrayList();
		this.preparedFunctionList2 = new ArrayList();
		
		this.COUNT_VAR = count_var;
		
		if (this.COUNT_VAR == 3) {
			
			this.REIHEN = 2;
			this.SPALTEN = 4;
			
			this.kvDiagrammVars = new String[this.REIHEN][this.SPALTEN];
			this.kvDiagrammMarked = new int[this.REIHEN][this.SPALTEN];
		}
		
		this.stringFunctionList = new ArrayList();
		ENDMINIList = new ArrayList();
		
		System.out.println("_______________________________________________________________________________________");
		System.out.println("_______________________________________________________________________________________");
		System.out.println("Karnaugh und Veitch - Verfahren:\n");
		prepareList();
	}
	
	/***/
	
	private void prepareList() {
		
		boolean ist_nicht = false;
		String nicht_in_klammern = (String)nichtKlammernList.get(0);
		
		for (int i = 0; i < functionList.size(); i++) {
			
			String content = (String)functionList.get(i);
			
			if (content.equals("&") && nicht_in_klammern.equals("&"))
				preparedFunctionList.add(content);
			else if (content.equals("V") && nicht_in_klammern.equals("V"))
				preparedFunctionList.add(content);
			else if (content.equals("a") && ist_nicht) {
				
				preparedFunctionList.add("-"+content);
				ist_nicht = false;
			}
			else if (content.equals("b") && ist_nicht) {
				
				preparedFunctionList.add("-"+content);
				ist_nicht = false;
			}
			else if (content.equals("c") && ist_nicht) {
	
				preparedFunctionList.add("-"+content);
				ist_nicht = false;
			}
			else if (content.equals("d") && ist_nicht) {
	
				preparedFunctionList.add("-"+content);
				ist_nicht = false;
			}
			else if (content.equals("a"))
				preparedFunctionList.add(content);
			else if (content.equals("b"))
				preparedFunctionList.add(content);
			else if (content.equals("c"))
				preparedFunctionList.add(content);
			else if (content.equals("d"))
				preparedFunctionList.add(content);
			else if (content.equals("-"))
				ist_nicht = true;
		}
		
		System.out.println("preparedFunctionList: "+preparedFunctionList.toString());
		System.out.println();
		
		//Die nun gefuellte preparedFunctionList nochmal durchlaufen,
		//um ein Arraylist anzulegen, indem bei jedem Listen-Element,
		//nochmals eine ArrayList eingefuegt wird, 
		//indem jeweils ein Term steht:
		ArrayList temp_term_list = new ArrayList();
		ArrayList term_komplett_list = new ArrayList();
		
		//Nur fuer diese Schleife muss in die preparedFunctionList ein & bzw V an den Schluss:
		preparedFunctionList.add(preparedFunctionList.size(), nicht_in_klammern);
		
		for (int e = 0; e < preparedFunctionList.size(); e++) {
			
			String tmp_content = (String)preparedFunctionList.get(e);
			
			if (!tmp_content.equals(nicht_in_klammern)) {
				
				temp_term_list.add(tmp_content);
			}
			else if (tmp_content.equals(nicht_in_klammern)) {
				
				
				term_komplett_list.add(temp_term_list);
				
				temp_term_list = null;
				temp_term_list = new ArrayList();
			}
		}
		
		//Jetzt kann das letzte & bzw V wieder aus der preparedFunctionList geloescht werden:
		preparedFunctionList.remove(preparedFunctionList.size() - 1);
		
		preparedFunctionList2 = term_komplett_list;
		term_komplett_list = null;
		
		System.out.println("=> preparedFunctionList2: "+preparedFunctionList2.toString());
		System.out.println("-----------------------------------------------------------------\n");
		
		//Konvertierung der einzelnen Listen in Strings:
		for (int j = 0; j < this.preparedFunctionList2.size(); j++) {
			
			ArrayList preparedTemp = (ArrayList)this.preparedFunctionList2.get(j);
			
			String tempTerm = "";
			
			for (int k = 0; k < preparedTemp.size(); k++) {
				
				tempTerm += (String)preparedTemp.get(k);
			}
			
			this.stringFunctionList.add(tempTerm);
		}
		
//		//ermitteln um wieviele Variablen es sich handelt:
//		ArrayList tempList = (ArrayList)this.preparedFunctionList2.get(0);
//		int anz_var = 0;
//		if (tempList.contains("d") || tempList.contains("-d"))
//			anz_var = 4;
//		else if (tempList.contains("c") || tempList.contains("-c"))
//			anz_var = 3;
//		else if (tempList.contains("b") || tempList.contains("-b"))
//			anz_var = 2;
		
//		//!!! Vorerst wird die Funktion hier aufgerufen: !!!
//		codeList(anz_var);
		
		fillKVDiagrammVars();
	}
	
	public void fillKVDiagrammVars() {
		
		//debug:
		System.out.println("stringFunctionList: "+this.stringFunctionList.toString());
		//debug_ende
		
		//1. Fuellen des ersten 2D-Arrays mit den einzelnen
		//Bezeichnungen der Felder:
		this.kvDiagrammVars[0][0] = "abc";
		this.kvDiagrammVars[0][1] = "ab-c";
		this.kvDiagrammVars[0][2] = "-ab-c";
		this.kvDiagrammVars[0][3] = "-abc";
		
		this.kvDiagrammVars[1][0] = "a-bc";
		this.kvDiagrammVars[1][1] = "a-b-c";
		this.kvDiagrammVars[1][2] = "-a-b-c";
		this.kvDiagrammVars[1][3] = "-a-bc";
		
		minimizeKARNAUGHVEITCH();
	}
	
	/**
	 * Ermittlung der minimalen, boolschen Funktion.
	 */
	private void minimizeKARNAUGHVEITCH() {
		
		ArrayList summarizedVars = new ArrayList();
		
		//2. Fuellen des zweiten 2D-Arrays mit den
		//entsprchenden Markierungen (1 oder 0)
		for (int i = 0; i < this.REIHEN; i++) {
			
			for (int j = 0; j < this.SPALTEN; j++) {
				
				String bezTemp = this.kvDiagrammVars[i][j];
				
				if (this.stringFunctionList.contains(bezTemp)) {
					
					this.kvDiagrammMarked[i][j] = 1;
					
				}
				else {
					
					this.kvDiagrammMarked[i][j] = 0;
				}
			}
		}
		
//		Abfragen der Mglichkeiten:
		ArrayList endList = new ArrayList();
		ArrayList endTemp = new ArrayList();
		
		if (this.kvDiagrammMarked[0][0] == 1 && this.kvDiagrammMarked[0][1] == 1
			&& this.kvDiagrammMarked[0][2] == 1 && this.kvDiagrammMarked[0][3] == 1
			&& this.kvDiagrammMarked[1][0] == 1 && this.kvDiagrammMarked[1][1] == 1
			&& this.kvDiagrammMarked[1][2] == 1 && this.kvDiagrammMarked[1][3] == 1) {
			
			endTemp.add("1");
			endList.add(endTemp);
			
			summarizedVars.add(this.kvDiagrammVars[0][0]);
			summarizedVars.add(this.kvDiagrammVars[0][1]);
			summarizedVars.add(this.kvDiagrammVars[0][2]);
			summarizedVars.add(this.kvDiagrammVars[0][3]);
			summarizedVars.add(this.kvDiagrammVars[1][0]);
			summarizedVars.add(this.kvDiagrammVars[1][1]);
			summarizedVars.add(this.kvDiagrammVars[1][2]);
			summarizedVars.add(this.kvDiagrammVars[1][3]);
			
			endTemp = null; endTemp = new ArrayList();
		}
		
		if (this.kvDiagrammMarked[0][0] == 1 && this.kvDiagrammMarked[0][1] == 1
			&& this.kvDiagrammMarked[0][2] == 1 && this.kvDiagrammMarked[0][3] == 1
			/*&& this.kvDiagrammMarked[1][0] == 0 && this.kvDiagrammMarked[1][1] == 0
			&& this.kvDiagrammMarked[1][2] == 0 && this.kvDiagrammMarked[1][3] == 0*/) {
			
			endTemp.add("b");
			
			if (!summarizedVars.contains((String)this.kvDiagrammVars[0][0]) || !summarizedVars.contains((String)this.kvDiagrammVars[0][1])
				|| !summarizedVars.contains((String)this.kvDiagrammVars[0][2]) || !summarizedVars.contains((String)this.kvDiagrammVars[0][3])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[0][0]);
				summarizedVars.add(this.kvDiagrammVars[0][1]);
				summarizedVars.add(this.kvDiagrammVars[0][2]);
				summarizedVars.add(this.kvDiagrammVars[0][3]);
			}

			endTemp = null; endTemp = new ArrayList();
		}
		
		if (this.kvDiagrammMarked[1][0] == 1 && this.kvDiagrammMarked[1][1] == 1
			&& this.kvDiagrammMarked[1][2] == 1 && this.kvDiagrammMarked[1][3] == 1) {
				
			endTemp.add("-b");
			
			if (!summarizedVars.contains((String)this.kvDiagrammVars[1][0]) || !summarizedVars.contains((String)this.kvDiagrammVars[1][1])
				|| !summarizedVars.contains((String)this.kvDiagrammVars[1][2]) || !summarizedVars.contains((String)this.kvDiagrammVars[1][3])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[1][0]);
				summarizedVars.add(this.kvDiagrammVars[1][1]);
				summarizedVars.add(this.kvDiagrammVars[1][2]);
				summarizedVars.add(this.kvDiagrammVars[1][3]);
			}

			endTemp = null; endTemp = new ArrayList();
		}
		
		if (this.kvDiagrammMarked[0][0] == 1 && this.kvDiagrammMarked[0][1] == 1
			&& this.kvDiagrammMarked[1][0] == 1 && this.kvDiagrammMarked[1][1] == 1) {
				
			endTemp.add("a");
			

			if (!summarizedVars.contains((String)this.kvDiagrammVars[0][0]) || !summarizedVars.contains((String)this.kvDiagrammVars[0][1])
				|| !summarizedVars.contains((String)this.kvDiagrammVars[1][0]) || !summarizedVars.contains((String)this.kvDiagrammVars[1][1])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[0][0]);
				summarizedVars.add(this.kvDiagrammVars[0][1]);
				summarizedVars.add(this.kvDiagrammVars[1][0]);
				summarizedVars.add(this.kvDiagrammVars[1][1]);
			}

			endTemp = null; endTemp = new ArrayList();
		}
		
		if (this.kvDiagrammMarked[0][1] == 1 && this.kvDiagrammMarked[0][2] == 1
			&& this.kvDiagrammMarked[1][1] == 1 && this.kvDiagrammMarked[1][2] == 1) {
				
			endTemp.add("-c");

			if (!summarizedVars.contains((String)this.kvDiagrammVars[0][1]) || !summarizedVars.contains((String)this.kvDiagrammVars[0][2])
				|| !summarizedVars.contains((String)this.kvDiagrammVars[1][1]) || !summarizedVars.contains((String)this.kvDiagrammVars[1][2])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[0][1]);
				summarizedVars.add(this.kvDiagrammVars[0][2]);
				summarizedVars.add(this.kvDiagrammVars[1][1]);
				summarizedVars.add(this.kvDiagrammVars[1][2]);
			}

			endTemp = null; endTemp = new ArrayList();
		}
		
		if (this.kvDiagrammMarked[0][2] == 1 && this.kvDiagrammMarked[0][3] == 1
			&& this.kvDiagrammMarked[1][2] == 1 && this.kvDiagrammMarked[1][3] == 1) {
				
			endTemp.add("-a");

			if (!summarizedVars.contains((String)this.kvDiagrammVars[0][2]) || !summarizedVars.contains((String)this.kvDiagrammVars[0][3])
				|| !summarizedVars.contains((String)this.kvDiagrammVars[1][2]) || !summarizedVars.contains((String)this.kvDiagrammVars[1][3])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[0][2]);
				summarizedVars.add(this.kvDiagrammVars[0][3]);
				summarizedVars.add(this.kvDiagrammVars[1][2]);
				summarizedVars.add(this.kvDiagrammVars[1][3]);
			}

			endTemp = null; endTemp = new ArrayList();
		}

		if (this.kvDiagrammMarked[0][3] == 1 && this.kvDiagrammMarked[0][0] == 1
			&& this.kvDiagrammMarked[1][3] == 1 && this.kvDiagrammMarked[1][0] == 1) {
				
			endTemp.add("c");

			if (!summarizedVars.contains((String)this.kvDiagrammVars[0][3]) || !summarizedVars.contains((String)this.kvDiagrammVars[0][0])
				|| !summarizedVars.contains((String)this.kvDiagrammVars[1][3]) || !summarizedVars.contains((String)this.kvDiagrammVars[1][0])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[0][2]);
				summarizedVars.add(this.kvDiagrammVars[0][3]);
				summarizedVars.add(this.kvDiagrammVars[1][2]);
				summarizedVars.add(this.kvDiagrammVars[1][3]);
			}

			endTemp = null; endTemp = new ArrayList();
		}
		
		if (this.kvDiagrammMarked[0][0] == 1 && this.kvDiagrammMarked[0][1] == 1) {
				
			endTemp.add("(");
			endTemp.add("a");
			endTemp.add("&");
			endTemp.add("b");
			endTemp.add(")");
			
			String temp1 = (String)this.kvDiagrammVars[0][0];
			String temp2 = (String)this.kvDiagrammVars[0][1];
			
			if (!summarizedVars.contains(temp1) || !summarizedVars.contains(temp2)) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[0][0]);
				summarizedVars.add(this.kvDiagrammVars[0][1]);
			}

			endTemp = null; endTemp = new ArrayList();
		}

		if (this.kvDiagrammMarked[0][1] == 1 && this.kvDiagrammMarked[0][2] == 1) {
			
			endTemp.add("(");
			endTemp.add("b");
			endTemp.add("&");
			endTemp.add("-c");
			endTemp.add(")");

			if (!summarizedVars.contains((String)this.kvDiagrammVars[0][1]) || !summarizedVars.contains((String)this.kvDiagrammVars[0][2])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[0][1]);
				summarizedVars.add(this.kvDiagrammVars[0][2]);
			}

			endTemp = null; endTemp = new ArrayList();
		}

		if (this.kvDiagrammMarked[0][2] == 1 && this.kvDiagrammMarked[0][3] == 1) {
			
			endTemp.add("(");
			endTemp.add("-a");
			endTemp.add("&");
			endTemp.add("b");
			endTemp.add(")");

			if (!summarizedVars.contains((String)this.kvDiagrammVars[0][2]) || !summarizedVars.contains((String)this.kvDiagrammVars[0][3])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[0][2]);
				summarizedVars.add(this.kvDiagrammVars[0][3]);
			}

			endTemp = null; endTemp = new ArrayList();
		}

		if (this.kvDiagrammMarked[0][3] == 1 && this.kvDiagrammMarked[0][0] == 1) {
			
			endTemp.add("(");
			endTemp.add("b");
			endTemp.add("&");
			endTemp.add("c");
			endTemp.add(")");

			if (!summarizedVars.contains((String)this.kvDiagrammVars[0][3]) || !summarizedVars.contains((String)this.kvDiagrammVars[0][0])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[0][3]);
				summarizedVars.add(this.kvDiagrammVars[0][0]);
			}

			endTemp = null; endTemp = new ArrayList();
		}

		if (this.kvDiagrammMarked[1][0] == 1 && this.kvDiagrammMarked[1][1] == 1) {
			
			endTemp.add("(");
			endTemp.add("a");
			endTemp.add("&");
			endTemp.add("-b");
			endTemp.add(")");

			if (!summarizedVars.contains((String)this.kvDiagrammVars[1][0]) || !summarizedVars.contains((String)this.kvDiagrammVars[1][1])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[1][0]);
				summarizedVars.add(this.kvDiagrammVars[1][1]);
			}

			endTemp = null; endTemp = new ArrayList();
		}

		if (this.kvDiagrammMarked[1][1] == 1 && this.kvDiagrammMarked[1][2] == 1) {
			
			endTemp.add("(");
			endTemp.add("-b");
			endTemp.add("&");
			endTemp.add("-c");
			endTemp.add(")");

			if (!summarizedVars.contains((String)this.kvDiagrammVars[1][1]) || !summarizedVars.contains((String)this.kvDiagrammVars[1][2])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[1][1]);
				summarizedVars.add(this.kvDiagrammVars[1][2]);
			}

			endTemp = null; endTemp = new ArrayList();
		}

		if (this.kvDiagrammMarked[1][2] == 1 && this.kvDiagrammMarked[1][3] == 1) {
			
			endTemp.add("(");
			endTemp.add("-a");
			endTemp.add("&");
			endTemp.add("-b");
			endTemp.add(")");

			if (!summarizedVars.contains((String)this.kvDiagrammVars[1][2]) || !summarizedVars.contains((String)this.kvDiagrammVars[1][3])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[1][2]);
				summarizedVars.add(this.kvDiagrammVars[1][3]);
			}

			endTemp = null; endTemp = new ArrayList();
		}
		
		if (this.kvDiagrammMarked[1][3] == 1 && this.kvDiagrammMarked[1][0] == 1) {
			
			endTemp.add("(");
			endTemp.add("-b");
			endTemp.add("&");
			endTemp.add("c");
			endTemp.add(")");

			if (!summarizedVars.contains((String)this.kvDiagrammVars[1][3]) || !summarizedVars.contains((String)this.kvDiagrammVars[1][0])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[1][3]);
				summarizedVars.add(this.kvDiagrammVars[1][0]);
			}

			endTemp = null; endTemp = new ArrayList();
		}
		
		if (this.kvDiagrammMarked[0][0] == 1 && this.kvDiagrammMarked[1][0] == 1) {
			
			endTemp.add("(");
			endTemp.add("a");
			endTemp.add("&");
			endTemp.add("c");
			endTemp.add(")");

			if (!summarizedVars.contains((String)this.kvDiagrammVars[0][0]) || !summarizedVars.contains((String)this.kvDiagrammVars[1][0])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[0][0]);
				summarizedVars.add(this.kvDiagrammVars[1][0]);
			}

			endTemp = null; endTemp = new ArrayList();
		}
		
		if (this.kvDiagrammMarked[0][1] == 1 && this.kvDiagrammMarked[1][1] == 1) {
			
			endTemp.add("(");
			endTemp.add("a");
			endTemp.add("&");
			endTemp.add("-c");
			endTemp.add(")");

			if (!summarizedVars.contains((String)this.kvDiagrammVars[0][1]) || !summarizedVars.contains((String)this.kvDiagrammVars[1][1])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[0][1]);
				summarizedVars.add(this.kvDiagrammVars[1][1]);
			}

			endTemp = null; endTemp = new ArrayList();
		}
		
		if (this.kvDiagrammMarked[0][2] == 1 && this.kvDiagrammMarked[1][2] == 1) {
			
			endTemp.add("(");
			endTemp.add("-a");
			endTemp.add("&");
			endTemp.add("-c");
			endTemp.add(")");

			if (!summarizedVars.contains((String)this.kvDiagrammVars[0][2]) || !summarizedVars.contains((String)this.kvDiagrammVars[1][2])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[0][2]);
				summarizedVars.add(this.kvDiagrammVars[1][1]);
			}

			endTemp = null; endTemp = new ArrayList();
		}
		
		if (this.kvDiagrammMarked[0][3] == 1 && this.kvDiagrammMarked[1][3] == 1) {
			
			endTemp.add("(");
			endTemp.add("-a");
			endTemp.add("&");
			endTemp.add("c");
			endTemp.add(")");

			if (!summarizedVars.contains((String)this.kvDiagrammVars[0][3]) || !summarizedVars.contains((String)this.kvDiagrammVars[1][3])) {
				
				endList.add(endTemp);
			
				summarizedVars.add(this.kvDiagrammVars[0][3]);
				summarizedVars.add(this.kvDiagrammVars[1][3]);
			}

			endTemp = null; endTemp = new ArrayList();
		}
		
		//debug
		show2DArrays();
		//debug_ende
		
		//debug:
//		System.out.println("\nsummarizedVars: "+summarizedVars.toString());
		System.out.println("\n-#-#-#-#-#-#-#--#-#-#---#-#-#-#-#-#-#-#-#-#-#-#-#-");
//		System.out.println("endList: "+endList.toString());
		//debug_ende
		
		prepareListToDraw(endList);
	}
	
	/**
	 * Die Liste wird so prepariert, damit gezeichnet werden kann.
	 * @param theList Die zu preparierende Liste
	 */
	private void prepareListToDraw(ArrayList theList) {
		
		ENDMINIList.add("");
		
		boolean first_time = true;
		
		for (int i = 0; i < theList.size(); i++) {
			
			ArrayList tempList = (ArrayList)theList.get(i);
			
			if (first_time)
				first_time = false;
			else
				ENDMINIList.add("V");
			
			for (int j = 0; j < tempList.size(); j++) {
				
				String tempVar = (String)tempList.get(j);

				if (tempVar.equals("-a")) {
					
					ENDMINIList.add("-");
					ENDMINIList.add("a");
				}
				else if (tempVar.equals("-b")) {
						
					ENDMINIList.add("-");
					ENDMINIList.add("b");
				}
				else if (tempVar.equals("-c")) {
					
					ENDMINIList.add("-");
					ENDMINIList.add("c");
				}
				else 
					ENDMINIList.add(tempVar);
			}
		}
		
		outputFunction(ENDMINIList);
	}
	
	/**
	 * Wandelt die Liste in einen String um. Dieser String
	 * wird dann in der GUI angezeigt.
	 * @param theList
	 */
	private void outputFunction(ArrayList theList) {
		
		String outputString = "";
	    
	    for (int i = 0; i < theList.size(); i++) {
	        
	        outputString += theList.get(i);
	    }
	    
	    //debug:
		System.out.println("ERGEBNIS: Die minimierte Funktion: "+outputString);
		//debug_ende
	    
	    MinimizerPanelFrame.setAusgabeTextPanel2(outputString);
	}
	
	public static ArrayList getENDMiniList() {
		
		return ENDMINIList;
	}
	
	/**
	 * Dient nur der Ausgabe der beiden kvDiargamm-Arrays.
	 */
	private void show2DArrays() {
		
		System.out.println("-------------------------------------\n");
		for (int i = 0; i < this.REIHEN; i++) {
			
			for (int j = 0; j < this.SPALTEN; j++) {
				
				System.out.print(this.kvDiagrammVars[i][j]+" ");
			}
			
			System.out.println();
		}
		System.out.println();
		for (int i = 0; i < this.REIHEN; i++) {
			
			for (int j = 0; j < this.SPALTEN; j++) {
				
				System.out.print(this.kvDiagrammMarked[i][j]+" ");
			}
			
			System.out.println();
		}
	}
}















