/*
 * Created on 06.01.2006
 */

/**
 * @author orko
 */

package minimizer_components;

import java.util.ArrayList;
import minimizer_gui.*;

public class MinimizeITQM {
	
	private ArrayList functionList;
	private ArrayList nichtKlammernList;
	private ArrayList preparedFunctionList;
	private ArrayList preparedFunctionList2;
	private ArrayList kodierteTermeList;
	
	private ArrayList twoTermsMinimized;
	private ArrayList allMiniTermTemp;
	
	private ArrayList ALLMiniTerms;
	
	//Diese Liste dient zur Speicherung der E-Elemente,
	//die schonmal minimiert wurden
	private ArrayList wurdeMinimiertListE;
	
	//Diese Liste dient zur Speicherung der trues bzw. false.
	//Wenn alle Elemente false sind, dann kann nicht weiter
	//minimiert werden.
	private ArrayList isEqualList;
	
	private ArrayList endCodeList;
	private static ArrayList ENDMiniList;
	
	public MinimizeITQM() {
		
		functionList = MinimizerTextfieldPanel.getTheOuputFunctionList();
		nichtKlammernList = MinimizerTextfieldPanel.getNichtKlammernList();
		preparedFunctionList = new ArrayList();
		preparedFunctionList2 = new ArrayList();
		kodierteTermeList = new ArrayList();
		
		twoTermsMinimized = new ArrayList();
		allMiniTermTemp = new ArrayList();
		isEqualList = new ArrayList();
		
		ALLMiniTerms = new ArrayList();
		
		wurdeMinimiertListE = new ArrayList();
		
		endCodeList = new ArrayList();
		ENDMiniList = new ArrayList();
		
		System.out.println("_______________________________________________________________________________________");
		System.out.println("_______________________________________________________________________________________");
		System.out.println("Quine und McCluskey - Verfahren:\n");
		prepareList();
	}
	
	/***/
	
	private void prepareList() {
		
		boolean ist_nicht = false;
		String nicht_in_klammern = (String)nichtKlammernList.get(0);
		
		for (int i = 0; i < functionList.size(); i++) {
			
			String content = (String)functionList.get(i);
			
			if (content.equals("&") && nicht_in_klammern.equals("&"))
				preparedFunctionList.add(content);
			else if (content.equals("V") && nicht_in_klammern.equals("V"))
				preparedFunctionList.add(content);
			else if (content.equals("a") && ist_nicht) {
				
				preparedFunctionList.add("-"+content);
				ist_nicht = false;
			}
			else if (content.equals("b") && ist_nicht) {
				
				preparedFunctionList.add("-"+content);
				ist_nicht = false;
			}
			else if (content.equals("c") && ist_nicht) {
	
				preparedFunctionList.add("-"+content);
				ist_nicht = false;
			}
			else if (content.equals("d") && ist_nicht) {
	
				preparedFunctionList.add("-"+content);
				ist_nicht = false;
			}
			else if (content.equals("a"))
				preparedFunctionList.add(content);
			else if (content.equals("b"))
				preparedFunctionList.add(content);
			else if (content.equals("c"))
				preparedFunctionList.add(content);
			else if (content.equals("d"))
				preparedFunctionList.add(content);
			else if (content.equals("-"))
				ist_nicht = true;
		}
		
		System.out.println("preparedFunctionList: "+preparedFunctionList.toString());
		System.out.println();
		
		//Die nun gefuellte preparedFunctionList nochmal durchlaufen,
		//um ein Arraylist anzulegen, indem bei jedem Listen-Element,
		//nochmals eine ArrayList eingefuegt wird, 
		//indem jeweils ein Term steht:
		ArrayList temp_term_list = new ArrayList();
		ArrayList term_komplett_list = new ArrayList();
		
		//Nur fuer diese Schleife muss in die preparedFunctionList ein & bzw V an den Schluss:
		preparedFunctionList.add(preparedFunctionList.size(), nicht_in_klammern);
		
		for (int e = 0; e < preparedFunctionList.size(); e++) {
			
			String tmp_content = (String)preparedFunctionList.get(e);
			
			if (!tmp_content.equals(nicht_in_klammern)) {
				
				temp_term_list.add(tmp_content);
			}
			else if (tmp_content.equals(nicht_in_klammern)) {
				
				
				term_komplett_list.add(temp_term_list);
				
				temp_term_list = null;
				temp_term_list = new ArrayList();
			}
		}
		
		//Jetzt kann das letzte & bzw V wieder aus der preparedFunctionList geloescht werden:
		preparedFunctionList.remove(preparedFunctionList.size() - 1);
		
		preparedFunctionList2 = term_komplett_list;
		term_komplett_list = null;
		
		System.out.println("=> preparedFunctionList2: "+preparedFunctionList2.toString());
		System.out.println("-----------------------------------------------------------------\n");
		
		//ermitteln um wieviele Variablen es sich handelt:
		ArrayList tempList = (ArrayList)this.preparedFunctionList2.get(0);
		int anz_var = 0;
		if (tempList.contains("d") || tempList.contains("-d"))
			anz_var = 4;
		else if (tempList.contains("c") || tempList.contains("-c"))
			anz_var = 3;
		else if (tempList.contains("b") || tempList.contains("-b"))
			anz_var = 2;
		
		//!!! Vorerst wird die Funktion hier aufgerufen: !!!
		codeList(anz_var);
	}
	
	protected void codeList(int anz_var) {
		
		//terme-array: erste Dimension: a b c d; zweite Dimension: die Terme
		final int VAR_SIZE = anz_var;
		final int TERM_SIZE = preparedFunctionList2.size();
//		ArrayList kodierteTermeList = new ArrayList();
		
		//Fuer jeden einzelnen Term muss jede Variable abgefragt werden und
		//entsprechend eine 1 (a) oder eine 0 (-a) eingesetzt werden:
		for (int i = 0; i < TERM_SIZE; i++) {
			
			ArrayList newTmpList = new ArrayList();
			
			for (int e = 0; e < VAR_SIZE; e++) {
				
				ArrayList oldTmpList = (ArrayList)preparedFunctionList2.get(i);
				String tmpVar = (String)oldTmpList.get(e);
				int tmp_code = -1;
				
				if (tmpVar.equals("-a") || tmpVar.equals("-b")
						|| tmpVar.equals("-c") || tmpVar.equals("-d")) {
					
					tmp_code = 0;
				}
				else
					tmp_code = 1;
				
				newTmpList.add(new Integer(tmp_code));
			}
			
			kodierteTermeList.add(newTmpList);
		}
		
//		//NUR ZUM DEFAULT-FUELLEN:
//		//ZUM TESTEN:
//		kodierteTermeList = fillCodeListDEFAULT();
		
		System.out.println("++++++++++++++++++++");
		System.out.println("kodierteTermeList: "+kodierteTermeList.toString()+"\n");
		showTermArrayList(preparedFunctionList2);
		System.out.println();
		showTermArrayList(kodierteTermeList);
		System.out.println("++++++++++++++++++++\n");
		
		minimizeQUINEMCCLUSKEY(kodierteTermeList, false);
	}
	
	/**
	 * Ermittlung der minimalen, boolschen Funktion.
	 * @param codeTermList
	 */
	private void minimizeQUINEMCCLUSKEY(ArrayList codeTermList, boolean delete_list) {
		
		//debug:
		System.out.println("\nAufruf: minimizeQUINEMCCLUSKEY mit der Liste: "+codeTermList.toString());
		//debug_ende
		
		if (delete_list)
			this.allMiniTermTemp = new ArrayList();
		
		boolean minimiert = false;
		
		for (int i = 0; i < (codeTermList.size()); i++) {
			
			ArrayList tmpTermListI = (ArrayList)codeTermList.get(i);
			
			for (int e = 1; e < codeTermList.size(); e++) {
				
				if (e >= i) {
					
					//debug:
					System.out.println("Vergleich: "+(i + 1)+" mit "+(e + 1));
					//debug_ende
					
					ArrayList tmpTermListE = (ArrayList)codeTermList.get(e);
					
					if (compareTermsAndMinimize(tmpTermListI, tmpTermListE)) {
						
						minimiert = true;
						
						this.wurdeMinimiertListE.add(new Integer(e));
						
						//debug:
						System.out.println("Es kann minimiert werden -> "
								+this.twoTermsMinimized.toString());
						//debug_end
						
						this.isEqualList.add("true");
						
						this.allMiniTermTemp.add(this.twoTermsMinimized);
						this.twoTermsMinimized = new ArrayList();
						
						System.out.println("allMiniTermTemp: "
								+this.allMiniTermTemp.toString());
					}
					else {
						
						this.isEqualList.add("false");
					}
				}
			}
			
			if (!minimiert) {
				
				//Nun in ALL, aber nur dann wenn nicht in wurdeMinimiertListE:
				if (!this.wurdeMinimiertListE.contains(new Integer(i))) {
					
					this.ALLMiniTerms.add(tmpTermListI);
				}
			}
			else
				minimiert = false;
		}
		
		this.wurdeMinimiertListE = null;
		this.wurdeMinimiertListE = new ArrayList();
		
		//Rekursive Aufruf:
		if (this.isEqualList.contains("true")
				&& this.allMiniTermTemp.size() != 1) {
			
			this.isEqualList = null;
			this.isEqualList = new ArrayList();
			
			minimizeQUINEMCCLUSKEY(this.allMiniTermTemp, true);
		}
		else {
			
			//Nun alle doppelten Terme eliminieren:
			eraseDoubleElementsFromALLList();
			
			//debug:
			System.out.println("\n============================");
			System.out.println("ALLES MINIMIERT, Ergebnis: "+this.ALLMiniTerms.toString());
			System.out.println();
			//debug_ende
			
			//Spaltendominanzpruefung: ---------------------------------------------
			ArrayList selectedTermList[] = new ArrayList[this.kodierteTermeList.size()];
			
			//Liste mit defaultwerten fuellen:
			for (int l = 0; l < selectedTermList.length; l++) {
				
				ArrayList testList = new ArrayList();
				testList.add(new Integer(-1));
				selectedTermList[l] = testList;
			}
			
			for (int j = 0; j < this.ALLMiniTerms.size(); j++) {
				
				ArrayList minTerm = (ArrayList)this.ALLMiniTerms.get(j);
				
				for (int k = 0; k < this.kodierteTermeList.size(); k++) {
					
					ArrayList codeTerm = (ArrayList)this.kodierteTermeList.get(k);
					ArrayList selectedTerm = selectedTermList[k];
					
//					if (selectedTerm != null) {
						
						if (compareMiniWithNormal(minTerm, codeTerm)) {
							
							selectedTermList[k] = minTerm;
						}
//					}
				}
			}
			
			this.endCodeList = eraseDoubleElementsFromArray(selectedTermList);
			
			//debug:
			System.out.println("\n>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
			System.out.println("Ergebnis der Pruefung: "+this.endCodeList.toString());
			//debug_ende
			
			//Umwandeln der kodierten Terme in normale Variablen:
			convertCodeTermToNormal();
			
			//debug:
			System.out.println("\n>============================================================");
			//debug_ende
			
			outputFunction(this.ENDMiniList);
		}
	}
	
	/**
	 * Diese Methode ueberprueft ob sich zwei Terme in nur einer Variable
	 * unterscheiden. Ist dies der Fall wird true zurueckgegeben,
	 * ansonsten wird false von dieser Methode zurueckgeliefert.
	 */
	private boolean compareTermsAndMinimize(ArrayList term1, ArrayList term2) {
		
		boolean term_is_equal = true;
		boolean unequally = false;
		boolean unequally_once = false;
		int unequally_index = -1;
		
		for (int i = 0; i < term1.size(); i++) {
			
			Integer t1 = (Integer)term1.get(i);
			Integer t2 = (Integer)term2.get(i);
			
			int t1_value = t1.intValue();
			int t2_value = t2.intValue();
			
			if (t1_value != t2_value) {
				
				unequally_once = true;
				
				if (!unequally) {
					
					unequally = true;
					unequally_index = i;
				}
				else {
					
					term_is_equal = false;
					unequally_index = -1;
				}
			}
		}
		
		//Markieren der Stelle im Term, welches zusammengefasst wird:
		//unequally_once dient der Ueberpruefung, dass wenigstens eine Variable
		//ungleich sein muss
		if (term_is_equal && unequally_once) {
			
			ArrayList tempListTerm1 = new ArrayList();
			tempListTerm1 = fillWithArrayList(term1);
			
			tempListTerm1.set(unequally_index, new Integer(-3));
			this.twoTermsMinimized = tempListTerm1;
		}
		else if (term_is_equal && !unequally_once) {
			
			term_is_equal = false;
		}
		
		return term_is_equal;
	}
	
	/**
	 * Diese Methode entfernt alle doppelten Listen
	 * aus der ArrayList this.ALLMiniTerms.
	 */
	private void eraseDoubleElementsFromALLList() {
		
		for (int i = 0; i < this.ALLMiniTerms.size(); i++) {
			
			ArrayList tempTermI = (ArrayList)this.ALLMiniTerms.get(i);
			
			for (int e = 0; e < this.ALLMiniTerms.size(); e++) {
				
				ArrayList tempTermE = (ArrayList)this.ALLMiniTerms.get(e);
				
				if (e > i) {
					
					if (tempTermI.equals(tempTermE)) {
						
						this.ALLMiniTerms.remove(i);
					}
				}
			}
		}
	}
	
	/**
	 * Diese Methode vergleicht zwei ArrayLists fuer die Spaltendominanzprfung,
	 * d.h. es wird geprueft ob der minimierte Term in den normalen Term "passt".
	 * @param miniTerm Der minimierte Term.
	 * @param normalTerm Der normale Term.
	 * @return terms_euqal Liefert true, wenn der minimierte Term in dem normalen passt.
	 */
	private boolean compareMiniWithNormal(ArrayList miniTerm, ArrayList normalTerm) {
		
		//debug
		System.out.println("Spaltendominanzpruefung:");
		System.out.println("Vergleichen von "+miniTerm.toString()+" mit ");
		System.out.print(normalTerm.toString());
		//debug_ende
		
		boolean terms_euqal = false;
		
		for (int i = 0; i < normalTerm.size(); i++) {
			
			Integer miniVar = (Integer)miniTerm.get(i);
			Integer normalVar = (Integer)normalTerm.get(i);
			
			if (!miniVar.equals(new Integer(-3))) {
				
				if (miniVar.equals(normalVar))
					terms_euqal = true;
				else
					terms_euqal = false;
			}
		}
		
//		debug
		System.out.println(" -> "+terms_euqal);
		//debug_ende
		
		return terms_euqal;
	}
	
	/**
	 * Diese Methode erzeugt eine Konsolen-basierte
	 * Ausgabe der Term-Liste
	 * @param the_list
	 */
	private void showTermArrayList(ArrayList theList) {
		
		for (int i = 0; i < theList.size(); i++) {
			
			ArrayList tempList = (ArrayList)theList.get(i);
			
			for (int e = 0; e < tempList.size(); e++) {
				
				System.out.print(tempList.get(e)+" ");
			}
			System.out.print(" : "+(i + 1));
			System.out.println();
		}
	}
	
	/**
	 * Dise Methode dient dem fuellen eines ArrayList mit
	 * einem anderem ArrayList. (Kein kopieren der Referenzen)
	 * @param theList
	 * @return tempList Die Liste mit dem kopierten Inhalt.
	 */
	private ArrayList fillWithArrayList(ArrayList theList) {
		
		ArrayList tempList = new ArrayList();
		
		for (int i = 0; i < theList.size(); i++) {
			
			tempList.add(theList.get(i));
		}
		
		return tempList;
	}
	
	/**
	 * Diese Methode entfernt alle doppelten Listen
	 * aus der ArrayList theList.
	 * @param theList
	 */
	private ArrayList eraseDoubleElementsFromArray(ArrayList theArray[]) {
		
		for (int i = 0; i < theArray.length; i++) {
			
			ArrayList tempTermI = theArray[i];
			
			for (int e = 0; e < theArray.length; e++) {
				
				ArrayList tempTermE = theArray[e];
				
				if (e > i) {
					
					if (tempTermI.equals(tempTermE)) {
						
						theArray[i] = null;
					}
				}
			}
		}
		
		ArrayList tempList = new ArrayList();
		
		for (int e = 0; e < theArray.length; e++) {
			
			ArrayList tempL2 = theArray[e];
			
			if (tempL2 != null)
				tempList.add(tempL2);
		}
		
		return tempList;
	}
	
	private void convertCodeTermToNormal() {
		
		boolean first_time = true;
		
		ArrayList tempEndList = new ArrayList();
		
		tempEndList.add("");
		
		for (int i = 0; i < this.endCodeList.size(); i++) {
			
//			ArrayList tempList = new ArrayList();
			
			if (!first_time)
				tempEndList.add("V");
			else
				first_time = false;
			
			tempEndList.add("(");
			
			ArrayList codeList = (ArrayList)this.endCodeList.get(i);
			
//			//debug:
//			System.out.println("codeLIst: "+codeList.toString());
//			//debug_ende
			
			int codelist_size = countEndList(codeList);
			
			for (int e = 0; e < codeList.size(); e++) {
				
				Integer code = (Integer)codeList.get(e);
				
				if (e == 0 && code.equals(new Integer(0))) {
					
					tempEndList.add("-");
					tempEndList.add("a");
					
					if (codelist_size > 1)
						tempEndList.add("&");
				}
				else if (e == 0 && code.equals(new Integer(1))) {
					
					tempEndList.add("a");
					
					if (codelist_size > 1)
						tempEndList.add("&");
				}
				
				else if (e == 1 && code.equals(new Integer(0))) {
					
					tempEndList.add("-");
					tempEndList.add("b");
					
					if (codelist_size > 2)
						tempEndList.add("&");
				}
				else if (e == 1 && code.equals(new Integer(1))) {
					
					tempEndList.add("b");
					
					if (codelist_size > 2)
						tempEndList.add("&");
				}
				
				else if (e == 2 && code.equals(new Integer(0))) {
					
					tempEndList.add("-");
					tempEndList.add("c");
					
					if (codelist_size > 3)
						tempEndList.add("&");
				}
				else if (e == 2 && code.equals(new Integer(1))) {
					
					tempEndList.add("c");
					
					if (codelist_size > 3)
						tempEndList.add("&");
				}
				
				else if (e == 3 && code.equals(new Integer(0))) {
					
					tempEndList.add("-");
					tempEndList.add("d");
					
					if (codelist_size > 4)
						tempEndList.add("&");
				}
				else if (e == 3 && code.equals(new Integer(1))) {
					
					tempEndList.add("d");

					if (codelist_size > 4)
						tempEndList.add("&");
				}
			}
			
			tempEndList.add(")");
			
//			tempEndList.add(tempEndList);
		}
		
		this.ENDMiniList = tempEndList;
	}

	/**
	 * Wandelt die Liste in einen String um. Dieser String
	 * wird dann in der GUI angezeigt.
	 * @param theList
	 */
	private void outputFunction(ArrayList theList) {
		
		String outputString = "";
	    
	    for (int i = 0; i < theList.size(); i++) {
	        
	        outputString += theList.get(i);
	    }
	    
	    //debug:
		System.out.println("ERGEBNIS: Die minimierte Funktion: "+outputString);
		//debug_ende
	    
	    MinimizerPanelFrame.setAusgabeTextPanel2(outputString);
	}
	
	/**
	 * Diese Methode dient zu zaehlen wie oft der default-wert -3
	 * in einer List vorkommen. (Dies ist nur eine Hilfsmethode)
	 * @param list
	 * @return
	 */
	private int countEndList(ArrayList list) {
		
		int count = 0;
		
		for (int i = 0; i < list.size(); i++) {
			
			Integer tempDigit = (Integer)list.get(i);
			
			if (!tempDigit.equals(new Integer(-3)))
				count++;
		}
		
		return count;
	}
	
	public static ArrayList getENDMiniList() {
		
		return ENDMiniList;
	}
	
//	/**
//	 * Diese Methode fuellt nur die kodierteFunctionList
//	 * mit Werten. (Damit die Funktion nicht immer eingegeben
//	 * werden muss)
//	 */
//	private ArrayList fillCodeListDEFAULT() {
//		
//		ArrayList codeListDEFAULT = new ArrayList();
//		
//		ArrayList list1 = new ArrayList();
//		ArrayList list2 = new ArrayList();
//		ArrayList list3 = new ArrayList();
//		ArrayList list4 = new ArrayList();
//		ArrayList list5 = new ArrayList();
//		ArrayList list6 = new ArrayList();
//		ArrayList list7 = new ArrayList();
//		
//		list1.add(new Integer(1)); list1.add(new Integer(1)); list1.add(new Integer(1)); list1.add(new Integer(0));
//		list2.add(new Integer(1)); list2.add(new Integer(1)); list2.add(new Integer(0)); list2.add(new Integer(1));
//		list3.add(new Integer(1)); list3.add(new Integer(1)); list3.add(new Integer(0)); list3.add(new Integer(0));
//		list4.add(new Integer(1)); list4.add(new Integer(0)); list4.add(new Integer(1)); list4.add(new Integer(0));
//		list5.add(new Integer(0)); list5.add(new Integer(0)); list5.add(new Integer(1)); list5.add(new Integer(1));
//		list6.add(new Integer(1)); list6.add(new Integer(0)); list6.add(new Integer(0)); list6.add(new Integer(0));
//		list7.add(new Integer(0)); list7.add(new Integer(0)); list7.add(new Integer(1)); list7.add(new Integer(0));
//		
//		codeListDEFAULT.add(list1);
//		codeListDEFAULT.add(list2);
//		codeListDEFAULT.add(list3);
//		codeListDEFAULT.add(list4);
//		codeListDEFAULT.add(list5);
//		codeListDEFAULT.add(list6);
//		codeListDEFAULT.add(list7);
//		
//		return codeListDEFAULT;
//	}
}















