package minimizer_gui;

import java.awt.Color;
import java.awt.Dimension;

/*
 * Created on 30.10.2005
 */

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

/**
 * @author orko
 */
public class MinimizerButtonPanel extends JPanel {
	
	MinimizerListener miniListener;
	
	/**
	 * Erzeugt dieses Panel-Objekt mit der angegebenen hoehe und breite.
	 * Auerdem muss diesem Konstruktor ein MinimizerListener-Objekt
	 * fr die Buttons bergeben werden.
	 * @param width die Breite des Panels
	 * @param height die Hhe des Panels
	 * @param miniListener der Listener fr die Buttons
	 */
	public MinimizerButtonPanel(int width, int height, MinimizerListener miniListener) {
		
		this.setPreferredSize(new Dimension(width, height));
		
		this.miniListener = miniListener;
		
		setTheButtonPanel();
	}
	
	/**
	 * Erzeugt dieses Panel-Objekt mit der angegebenen hhe und breite und Farbe.
	 * Auerdem muss diesem Konstruktor ein MinimizerListener-Objekt
	 * fr die Buttons bergeben werden.
	 * @param width width die Breite des Panels
	 * @param height width die Hhe des Panels
	 * @param color width die Farbe des Panels
	 * @param miniListener miniListener der Listener fr die Buttons
	 */
	public MinimizerButtonPanel(int width, int height, Color color, MinimizerListener miniListener) {
		
		this.setPreferredSize(new Dimension(width, height));
		this.setBackground(color);
		
		this.miniListener = miniListener;
		
		setTheButtonPanel();
	}
	
	/***/
	
	/**
	 * Diese Methode legt ein bestimmtes Panel als
	 * ein Button-Panel fest:
	 */
	private void setTheButtonPanel() {
		
		JButton open = new JButton("(");
		JButton a = new JButton("a");
		JButton b = new JButton("b");
		JButton c = new JButton("c");
		JButton d = new JButton("d");
		
		JButton close = new JButton(")");
		JButton and = new JButton("&");
		JButton or = new JButton("V");
		JButton not = new JButton("-");
		JButton del = new JButton("<-");
		
		del.setForeground(Color.gray);
		
		this.add(open);
		this.add(a);
		this.add(b);
		this.add(c);
		this.add(d);
		
		this.add(close);
		this.add(and);
		this.add(or);
		this.add(not);
		this.add(del);
		
		
		
		open.addActionListener(this.miniListener);
		a.addActionListener(this.miniListener);
		b.addActionListener(this.miniListener);
		c.addActionListener(this.miniListener);
		d.addActionListener(this.miniListener);
		close.addActionListener(this.miniListener);
		and.addActionListener(this.miniListener);
		or.addActionListener(this.miniListener);
		not.addActionListener(this.miniListener);
		del.addActionListener(this.miniListener);
	}
}












