package minimizer_gui;

/*
 * Created on 28.10.2005
 */

import java.awt.event.*;
import minimizer_components.MinimizeITQM;
import minimizer_components.MinimizeITKV;

/**
 * @author orko
 */
public class MinimizerListener implements ActionListener {
	
	private MinimizerTextfieldPanel miniTextPanel;
	private MinimizerSchaltungPanel miniSchaltPanel;
	
	//Zum setzen des zu verwendeten Algorithmus:
	private boolean qm_is_set = false;
	private boolean kv_is_set = false;
	
	public MinimizerListener(MinimizerTextfieldPanel mtp) {
		
		miniTextPanel = mtp;
	}
	
	public MinimizerListener(MinimizerSchaltungPanel msp) {
		
	    miniSchaltPanel = msp;
	}
	
	/***/
	
	public void actionPerformed(ActionEvent ae) {
		
	    if (ae.getActionCommand().equals("Draw Normal"))
	        miniSchaltPanel.drawSchaltung();
	    else if (ae.getActionCommand().equals("Minimize")) {
	    	
	    	MinimizerTextfieldPanel.eraseOutputList();
	    	if (this.qm_is_set) {
	    		
	    		MinimizeITQM minimizeITQM = new MinimizeITQM();
	    	}
	    	else if (this.kv_is_set) {
	    		
	    		MinimizeITKV minimizeITKV = new MinimizeITKV(3);
	    	}
	    	//debug:
	    	else
	    		System.out.println("\nEs wurde kein Algorithmus ausgewaehlt!\n");
	    	//debug_ende
	    }
		else if (ae.getActionCommand().equals("Draw Mini")) {
			
			MinimizerTextfieldPanel.eraseOutputList();
			
			if (this.qm_is_set)
				MinimizerTextfieldPanel.setTheOuputFunctionList(MinimizeITQM.getENDMiniList());
			else if (this.kv_is_set)
				MinimizerTextfieldPanel.setTheOuputFunctionList(MinimizeITKV.getENDMiniList());
			
			miniSchaltPanel.drawSchaltung();
		}
	    else 
	        miniTextPanel.setTextfieldOutput(ae.getActionCommand(), "default");
	}
	
	/**
	 * Diese Methode legt fest, welchen Algorithmus verwendet werden soll.
	 * @param qm_is_set True wenn Quine-McCluskey verwendet werden soll.
	 * @param kv_is_set True wenn KV-Verfahren verwendet werden soll.
	 */
	public void setMinimizerAlgorithm(boolean qm_is_set, boolean kv_is_set) {
		
		this.qm_is_set = qm_is_set;
		this.kv_is_set = kv_is_set;
	}
}









