package minimizer_gui;

/*
 * Created on 27.10.2005
 */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * @author orko
 */
public class MinimizerPanelFrame extends MinimizerFrame implements ItemListener {
	
	private static MinimizerTextfieldPanel ausgabeTextPanel2;
	
	//RadioButton der kompletten Klasse bekannt machen:
	private JRadioButton quineRadioB;
	private JRadioButton kvRadioB;
	
	//Die Zeichnen-LIstener der Klasse bekannt machen:
	private MinimizerListener miniListener;
	private MinimizerListener miniListener2;
	private MinimizerListener miniListener3;
	
	public MinimizerPanelFrame() {
		
		MinimizerPanel eingabePanel = new MinimizerPanel(10, 120);
		
		MinimizerTextfieldPanel ausgabeTextPanel = new MinimizerTextfieldPanel(800, 20, Color.white);
		
		this.miniListener = new MinimizerListener(ausgabeTextPanel);
		MinimizerButtonPanel eingabeButtonPanel = new MinimizerButtonPanel(400, 75, miniListener);
		
		this.quineRadioB = new JRadioButton("QM");
		this.kvRadioB = new JRadioButton("KV");
		this.quineRadioB.addItemListener(this);
		this.kvRadioB.addItemListener(this);
		ButtonGroup radioBGroup = new ButtonGroup();
		radioBGroup.add(this.quineRadioB);
		radioBGroup.add(this.kvRadioB);
		
		eingabePanel.add(quineRadioB);
		eingabePanel.add(kvRadioB);
		
		eingabePanel.add(eingabeButtonPanel, "West");
		eingabePanel.add(ausgabeTextPanel, "East");
		
		MinimizerSchaltungPanel schaltungPanel = new MinimizerSchaltungPanel(10, 300, new Color(250, 250, 250), ausgabeTextPanel);
		JButton zeichneButton = new JButton("Draw Normal");
		this.miniListener2 = new MinimizerListener(schaltungPanel);
		zeichneButton.addActionListener(miniListener2);
		schaltungPanel.add(zeichneButton);
		
		MinimizerSchaltungPanel miniSchaltungPanel = new MinimizerSchaltungPanel(10, 300, new Color(243, 243, 243), ausgabeTextPanel);
		JButton minimiereButton = new JButton("Minimize");
		this.miniListener3 = new MinimizerListener(miniSchaltungPanel);
		minimiereButton.addActionListener(miniListener3);
		
		JButton zeichneButton2 = new JButton("Draw Mini");
		zeichneButton2.addActionListener(miniListener3);
		
		ausgabeTextPanel2 = new MinimizerTextfieldPanel(400, 20, Color.LIGHT_GRAY);
		ausgabeTextPanel2.setTextfieldOutput("", "kein default");
		miniSchaltungPanel.add(minimiereButton);
		miniSchaltungPanel.add(zeichneButton2);
		miniSchaltungPanel.add(ausgabeTextPanel2);
		
		this.getContentPane().setLayout(new BorderLayout());
		
		this.getContentPane().add(eingabePanel, "North");
		this.getContentPane().add(schaltungPanel);
		this.getContentPane().add(miniSchaltungPanel, "South");
	}
	
	public static void setAusgabeTextPanel2(String text) {
		
		ausgabeTextPanel2.setTextfieldOutput(text, "kein default");
	}
	
	public void itemStateChanged (ItemEvent ie) {
		
		if (this.quineRadioB.isSelected()) {
			
			this.miniListener.setMinimizerAlgorithm(true, false);
			this.miniListener2.setMinimizerAlgorithm(true, false);
			this.miniListener3.setMinimizerAlgorithm(true, false);
		}	
		else if (this.kvRadioB.isSelected()) {
			
			this.miniListener.setMinimizerAlgorithm(false, true);
			this.miniListener2.setMinimizerAlgorithm(false, true);
			this.miniListener3.setMinimizerAlgorithm(false, true);
		}
			
	}
}













