/*
 * Created on 03.11.2005
 */
package minimizer_gui;

/**
 * @author ORKObv
 * @version
 */

import java.awt.*;
import java.util.ArrayList;

import javax.swing.JPanel;
import minimizer_components.*;

public class MinimizerSchaltungPanel extends JPanel {
    
    private boolean draw = false;
    private MinimizerTextfieldPanel textFieldPanel;
    private ArrayList outputList;
    private ArrayList varKlammernList;
    
    public MinimizerSchaltungPanel(int width, int height, Color color, MinimizerTextfieldPanel textFieldPanel){
		
		this.setPreferredSize(new Dimension(width, height));
		this.setBackground(color);
		
		this.textFieldPanel = textFieldPanel;
	}
    
    /***/
    
    public void paintComponent(Graphics g) {
        
        super.paintComponent(g);
        
        if (this.draw == true) {
        	
        	ArrayList listWithMinus = prepareList();
        	
        	//In dieser Liste werden die Rechte-Kante-Mittelpunkt-Koordinaten der ANDs
        	//gespeichert, um das sptere OR mit den richtigen Linien zu den ANDs
        	//zeichnen zu knnen:
        	ArrayList andMiddleCoordinates = new ArrayList();
            
            ArrayList variablenList = (ArrayList)outputList.get(0);
            ArrayList klammernList = (ArrayList)outputList.get(1);
            ArrayList nichtKlammernList = (ArrayList)outputList.get(2);
            
            boolean a = false;
            boolean b = false;
            boolean c = false;
            boolean d = false;
            
	        int y_start = 50;
	        int y_forlaufend = y_start;
	        int x_start = 100;
	        
	        int oval_dm = 6;
	        int oval_radius = oval_dm / 2;
	        
	        //Zeichnen der Variablen mit den Punkten:
	        String outputVariable;
	        for (int i = 0; i < variablenList.size(); i++) {
	            
	            outputVariable = (String)variablenList.get(i);
	            
	            if (outputVariable.equals("a")) {
	                
	                g.drawString("a", 20, 30);
	                g.fillOval(20, 35, oval_dm, oval_dm);
	                
	                a = true;
	            }
	            else if (outputVariable.equals("b")) {
	                
	                g.drawString("b", 35, 30);
	                g.fillOval(35, 35, oval_dm, oval_dm);
	                
	                b = true;
	            }
	            else if (outputVariable.equals("c")) {
	                
	                g.drawString("c", 50, 30);
	                g.fillOval(50, 35, oval_dm, oval_dm);
	                
	                c = true;
	            }
	            else if (outputVariable.equals("d")) {
	                
			        g.drawString("d", 65, 30);
			        g.fillOval(65, 35, oval_dm, oval_dm);
	                
	                d = true;
	            }
        	}
	        
	        //Zeichnen der Verknuepfungen innerhalb der Klammern:
	        String klammernVariable = (String)klammernList.get(0);
	        String stringTemp;
	        if (klammernList.size() > 1) {
	            stringTemp = (String)klammernList.get(1);
	        }
	        else {
	            stringTemp = "0";
	        }
	        int klammernAnzahl = Integer.parseInt(stringTemp);
	        
            if (klammernVariable.equals("&")) {
                
                And and = new And(x_start, y_forlaufend, a, b, c, d);
                
                ArrayList varKlammernListWithMinus = convertToMinus(listWithMinus);
                boolean zeichneFirstTime = true;
                for (int e = 0; e < klammernAnzahl; e++) {
                	
                	//rauziehen der jeweiligen Variablen aus
                	//den entsprechenden Klammern:
//                	ArrayList var_klammern_temp =(ArrayList)varKlammernList.get(e);
                	ArrayList var_klammern_temp = (ArrayList)varKlammernListWithMinus.get(e);
                	boolean a2 = false, b2 = false, c2 = false, d2 = false;
                	boolean a_minus = false, b_minus = false, c_minus = false, d_minus = false;
                	for (int j = 0; j < var_klammern_temp.size(); j++) {
                		
                		String var_tmp = (String)var_klammern_temp.get(j);
                		if (var_tmp.equals("a"))
                			a2 = true;
                		if (var_tmp.equals("b"))
                			b2 = true;
                		if (var_tmp.equals("c"))
                			c2 = true;
                		if (var_tmp.equals("d"))
                			d2 = true;
                		
                		if (var_tmp.equals("-a")) {
                			
                			a2 = true;
                			a_minus = true;
                		}
                		if (var_tmp.equals("-b")) {
                			
                			b2 = true;
                			b_minus = true;
                		}
                		if (var_tmp.equals("-c")) {
                			
                			c2 = true;
                			c_minus = true;
                		}
                		if (var_tmp.equals("-d")) {
                			
                			d2 = true;
                			d_minus = true;
                		}
                	}
                	and.setABCD(a2, b2, c2, d2, a_minus, b_minus, c_minus, d_minus);
                    
                    if (zeichneFirstTime) {
                        
                        and.drawAnd(g, true);
                        zeichneFirstTime = false;
                        
                        int mid_coor = and.getY() + (and.getHeight() / 2);
                        andMiddleCoordinates.add(new Integer(mid_coor));
                    }
                    else {
                        and.drawAnd(g, x_start, y_forlaufend += (and.getHeight() + 5));
                        
                        int mid_coor = and.getNewY() + (and.getHeight() / 2);
                        andMiddleCoordinates.add(new Integer(mid_coor));
                    }
                }
                zeichneFirstTime = true;
                
                if (a)
                    g.drawLine(20 + oval_radius, 35 + oval_radius, 20 + oval_radius, y_forlaufend + and.getHeight());
                if (b)
                    g.drawLine(35 + oval_radius, 35 + oval_radius, 35 + oval_radius, y_forlaufend + and.getHeight());
                if (c)
                    g.drawLine(50 + oval_radius, 35 + oval_radius, 50 + oval_radius, y_forlaufend + and.getHeight());
                if (d)
                    g.drawLine(65 + oval_radius, 35 + oval_radius, 65 + oval_radius, y_forlaufend + and.getHeight());
                
                //Zeichnen der Verknuepfungen auserhalb der Klammer;
                int gesamtLaenge = y_forlaufend - y_start;
                String nichtKlammerVariable;
                if (nichtKlammernList.size() > 0) {
                    nichtKlammerVariable = (String)nichtKlammernList.get(0);
                }
                else {
                    nichtKlammerVariable = "default";
                }
                if (nichtKlammerVariable.equals("V")) {
                	
                    Or or = new Or(and.getX() + and.getLength() * 2, (gesamtLaenge / 2) + y_start, a, b, c, d);
        	        or.drawOr(g, false);
        	        
        	        //Die Linie von OR zur den ANDs:
        	        int or_line_x1 = and.getX() + and.getLength() * 2;
        	        int or_line_y1 = (gesamtLaenge / 2) + y_start;
        	        int or_line_x2 = or_line_x1 - 10;
        	        
        	        or_line_y1 += or.getHeight() / 2;
        	        
        	        g.drawLine(or_line_x1, or_line_y1, or_line_x2 , or_line_y1);
        	        
        	        int x_von_ands = and.getX() + and.getLength();
        	        for (int i = 0; i < andMiddleCoordinates.size(); i++) {
        	        	
        	        	Integer iTemp = (Integer)andMiddleCoordinates.get(i);
        	        	int new_y2 = iTemp.intValue();
        	        	
        	        	g.drawLine(or_line_x2, or_line_y1, x_von_ands, new_y2);
        	        }
                }
            }
            else if (klammernVariable.equals("V")) {
	                
                Or or = new Or(x_start, y_forlaufend, a, b, c, d);
                
                boolean zeichneFirstTime = true;
                for (int e = 0; e < klammernAnzahl; e++) {
                	
                	//rauziehen der jeweiligen Variablen aus
                	//den entsprechenden Klammern:
                	ArrayList var_klammern_temp =(ArrayList)varKlammernList.get(e);
                	boolean a2 = false, b2 = false, c2 = false, d2 = false;
                	for (int j = 0; j < var_klammern_temp.size(); j++) {
                		
                		String var_tmp = (String)var_klammern_temp.get(j);
                		if (var_tmp.equals("a"))
                			a2 = true;
                		if (var_tmp.equals("b"))
                			b2 = true;
                		if (var_tmp.equals("c"))
                			c2 = true;
                		if (var_tmp.equals("d"))
                			d2 = true;
                	}
                	or.setABCD(a2, b2, c2, d2);
                    
                    if (zeichneFirstTime) {
                        
                        or.drawOr(g, true);
                        zeichneFirstTime = false;
                    }
                    else {
                        or.drawOr(g, x_start, y_forlaufend += (or.getHeight() + 5));
                    }
                }
                zeichneFirstTime = true;
                
                if (a)
                    g.drawLine(20 + oval_radius, 35 + oval_radius, 20 + oval_radius, y_forlaufend + or.getHeight());
                if (b)
                    g.drawLine(35 + oval_radius, 35 + oval_radius, 35 + oval_radius, y_forlaufend + or.getHeight());
                if (c)
                    g.drawLine(50 + oval_radius, 35 + oval_radius, 50 + oval_radius, y_forlaufend + or.getHeight());
                if (d)
                    g.drawLine(65 + oval_radius, 35 + oval_radius, 65 + oval_radius, y_forlaufend + or.getHeight());
                
                //Zeichnen der Verknpfungen auserhalb der Klammer;
                int gesamtLaenge = y_forlaufend - y_start;
                String nichtKlammerVariable;
                if (nichtKlammernList.size() > 0) {
                    nichtKlammerVariable = (String)nichtKlammernList.get(0);
                }
                else {
                    nichtKlammerVariable = "default";
                }
                if (nichtKlammerVariable.equals("&")) {
                	
                    And and = new And(or.getX() + or.getLength() * 2, (gesamtLaenge / 2) + y_start, a, b, c, d);
        	        and.drawAnd(g, false);
                }
            }
        }
    }
    
    public void drawSchaltung() {
        
        if (this.draw == false) {
            
            this.draw = true;
            this.outputList = textFieldPanel.getOutputList();
            this.varKlammernList = textFieldPanel.getVariableInKlammernList();
            
            //debug:
//            System.out.println("OutputList: "+outputList.toString());
//            System.out.println("varKlammernList: "+varKlammernList.toString());
            System.out.println("--------------------------------------------------------------------");
            System.out.println();
            //debug_ende
        }
        else {
            
            this.draw = false;
            MinimizerTextfieldPanel.eraseOutputList();
        }
        
        repaint();
    }
    
    /**
	 * Diese Methode ist zur Zeitverzoegerung.
	 */
	private void delay(long time) {
		try {
			Thread.sleep(time);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
	
	private ArrayList prepareList() {
		
		ArrayList preparedFunctionList = new ArrayList();
		ArrayList functionList = MinimizerTextfieldPanel.getTheOuputFunctionList();
		ArrayList nichtKlammernList = MinimizerTextfieldPanel.getNichtKlammernList();
		
		boolean ist_nicht = false;
		String nicht_in_klammern = (String)nichtKlammernList.get(0);
		
		for (int i = 0; i < functionList.size(); i++) {
			
			String content = (String)functionList.get(i);
			
			if (content.equals("&") && nicht_in_klammern.equals("&"))
				preparedFunctionList.add(content);
			else if (content.equals("V") && nicht_in_klammern.equals("V"))
				preparedFunctionList.add(content);
			else if (content.equals("a") && ist_nicht) {
				
				preparedFunctionList.add("-"+content);
				ist_nicht = false;
			}
			else if (content.equals("b") && ist_nicht) {
				
				preparedFunctionList.add("-"+content);
				ist_nicht = false;
			}
			else if (content.equals("c") && ist_nicht) {
	
				preparedFunctionList.add("-"+content);
				ist_nicht = false;
			}
			else if (content.equals("d") && ist_nicht) {
	
				preparedFunctionList.add("-"+content);
				ist_nicht = false;
			}
			else if (content.equals("a"))
				preparedFunctionList.add(content);
			else if (content.equals("b"))
				preparedFunctionList.add(content);
			else if (content.equals("c"))
				preparedFunctionList.add(content);
			else if (content.equals("d"))
				preparedFunctionList.add(content);
			else if (content.equals("-"))
				ist_nicht = true;
		}
		
		return preparedFunctionList;
	}
	
	private ArrayList convertToMinus(ArrayList theList) {
		
		theList.add("V");
		
		ArrayList varKlammernListWithMinus = new ArrayList();
		ArrayList tempList = new ArrayList();
		
		for (int i = 0; i < theList.size(); i++) {
			
			String tempVar = (String)theList.get(i);
			
			if (!tempVar.equals("V"))
				tempList.add(tempVar);
			else {
				
				varKlammernListWithMinus.add(tempList);
				tempList = null; tempList = new ArrayList();
			}
		}
		
//		//debug
//		System.out.println(" varKlammernListWithMinus: "+varKlammernListWithMinus.toString());
//		System.exit(0);
//		//debug_ende
		
		return varKlammernListWithMinus;
	}
}















