package minimizer_gui;

import java.awt.Color;
import java.awt.Dimension;

import java.util.ArrayList;

/*
 * Created on 30.10.2005
 */

import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * @author orko
 */
public class MinimizerTextfieldPanel extends JPanel {
	
	JLabel textOutputLabel;
	static ArrayList ouputFunctionList = new ArrayList();
	private static ArrayList ouputList = new ArrayList();
	ArrayList variableInKlammernList;
	static ArrayList nichtKlammernList = new ArrayList();
	
	/**
	 * Erzeugt dieses Panel-Objekt mit der angegebenen hhe und breite:
	 * @param width die Breite des Panels
	 * @param height die Hhe des Panels
	 */
	public MinimizerTextfieldPanel(int width, int height){
		
		this.setPreferredSize(new Dimension(width, height));
		
		setTheTextfieldPanel();
	}
	
	/**
	 * Erzeugt dieses Panel-Objekt mit der angegebenen hhe und breite und Farbe:
	 * @param width die Breite des Panels
	 * @param height die Hhe des Panels
	 * @param color die Farbe des Panels
	 */
	public MinimizerTextfieldPanel(int width, int height, Color color){
		
		this.setPreferredSize(new Dimension(width, height));
		this.setBackground(color);
		
		setTheTextfieldPanel();
	}
	
	/**
	 * Diese Methode legt ein bestimmtes Panel
	 * als Textfield-Panel fest:
	 */
	private void setTheTextfieldPanel() {
		
		textOutputLabel = new JLabel();
		this.add(textOutputLabel);
	}
	
	/**
	 * In dieser Methode setze ich den output des Textfeldes:
	 * @param output der Output-String
	 */
	protected void setTextfieldOutput(String command, String _switch) {
		
		if (command.compareTo("<-") == 0) {
			
			try {
				ouputFunctionList.remove(ouputFunctionList.size() - 1);
			}
			catch(IndexOutOfBoundsException ioobe){}
		}
		else
			ouputFunctionList.add(command);
		
		if (_switch.equals("default"))
			textOutputLabel.setText(outputToString(ouputFunctionList));
		else {
			
			textOutputLabel.setText(command);
		}
	}
	
	private void parseOutputList() {
	    
	    ArrayList outList = this.ouputFunctionList;
	    
	    //debug:
		System.out.println("Die Liste: "+outList.toString());
		//debug_ende
	    
	    ArrayList variablenList = new ArrayList();
	    boolean a = true;
	    boolean b = true;
	    boolean c = true;
	    boolean d = true;
	    
	    ArrayList klammernList = new ArrayList();
	    boolean klammerAuf = false;
	    boolean klammerZu = false;
	    boolean klammernVariableGesetzt = false;
	    int klammernCounter = 0;
	    
//	    ArrayList nichtKlammernList = new ArrayList();
	    boolean nichtKlammernVariableGesetzt = false;
	    
	    //In diesem ArrayList-Objekt werden die Variablen gespeichert,
	    //die sich in den jeweiligen Klammern befinden:
	    variableInKlammernList = new ArrayList();
	    ArrayList variablen = new ArrayList();
	    boolean variable_in_klammern_auf = false;
//	   	boolean variable_in_klammern_zu = false;
	    
	    for (int i = 0; i < outList.size(); i++) {
	        
	        String outVariable = (String)outList.get(i);
	        
	        // Rausziehen der Variablen die in dem Ausdruck vorkommen: --------------------------------------
	        if (outVariable.equals("a") && a == true) {
	            
	            variablenList.add(outVariable);
	            a = false;
	        }
	        else if (outVariable.equals("b") && b == true) {
	            
	            variablenList.add(outVariable);
	            b = false;
	        }
	        else if (outVariable.equals("c") && c == true) {
	            
	            variablenList.add(outVariable);
	            c = false;
	        }
	        else if (outVariable.equals("d") && d == true) {
	            
	            variablenList.add(outVariable);
	            d = false;
	        }
	        //----------------------------------------------------------------------------------------------------------------
	        
	        //Rausziehen welche Variablen in den jeweiligen Klammern stehen: ------------------------
	        if (outVariable.equals("(")) {
	        	
	        	variablen = new ArrayList();
	        	variable_in_klammern_auf = true;
	        }
	        if (variable_in_klammern_auf
	        	&& (outVariable.equals("a") || outVariable.equals("b") || outVariable.equals("c") || outVariable.equals("d"))) {
	        	
	        	variablen.add(outVariable);
	        }
	        if (outVariable.equals(")")) {
	        	
	        	variableInKlammernList.add(variablen);
	        	variablen = null;
	        	variable_in_klammern_auf = false;
	        }
	        //-----------------------------------------------------------------------------------------------------------
	        
	        // Rausziehen was in der Klammer steht: ---------------------------------------------------------
	        if (outVariable.equals("(") && klammerZu == false) {
	            
	            klammerAuf = true;
	            klammerZu = true;
	        }
	        else if ((klammerAuf == true && klammerZu == true)
	                && (outVariable.equals("&") || outVariable.equals("V"))) {
	    	    
	            if (klammernVariableGesetzt == false)
	                klammernList.add(outVariable);
	            
	    	    klammernVariableGesetzt = true;
	    	    
	    	    klammernCounter++;
	    	    klammerZu = false;
	    	}
	    	else if (klammerAuf == true && outVariable.equals(")")) {
	    	    klammerZu = false;
	    	}
	    	//Rausziehen was auserhalb der Klammer steht: --------------------------------------------------
	    	else if ((klammerAuf == true && klammerZu == false)
	    	        && nichtKlammernVariableGesetzt == false
	                && (outVariable.equals("&") || outVariable.equals("V"))) {
	    		
	    		//!!! getrickst !!!
	    		String klammer_temp = (String)klammernList.get(0);
	    		if (klammer_temp.equals("&"))
	    			outVariable = "V";
	    		else if (klammer_temp.equals("V"))
	    			outVariable = "&";
	    		//!!! getrickst_ende !!!
	    	    
	    	    nichtKlammernList.add(outVariable);
    	    	nichtKlammernVariableGesetzt = true;
	    	}
	    	//-----------------------------------------------------------------------------------------------
	        //-----------------------------------------------------------------------------------------------
	    }
	    String klammernCounterString = Integer.toString(klammernCounter);
	    klammernList.add(klammernCounterString);
	    
	    ouputList.add(variablenList);
	    ouputList.add(klammernList);
	    ouputList.add(nichtKlammernList);
	    
//	    System.out.println("Variablen-List: " + variablenList.toString());
//	    System.out.println("Klammern-List: " + klammernList.toString());
//	    System.out.println("nichtKlammern-List: " + nichtKlammernList.toString());
//	    System.out.println("variableINKlammern-List: " + variableInKlammernList.toString());
//	    System.out.println();
//	    System.out.println("OUTPUT-FUNCTION-LIST: " + ouputFunctionList.toString());
//	    System.out.println();
	}
	
	/**
	 * Wandelt die ouput-Liste in ein gut lesbaren String um:
	 * @param output Die Arrayliste, die in ein String umgewandelt wird
	 * @return Der String der ArrayListe
	 */
	private String outputToString(ArrayList output) {
	    
	    String outputString = "";
	    
	    for (int i = 0; i < output.size(); i++) {
	        
	        outputString += output.get(i);
	    }
	    
	    return outputString;
	}
	
	/**
	 * Ueber diese Methode erhaltet man die ArrayList mit dem logischen Ausdruck
	 * @return ArrayList mit dem logischen Ausdruck
	 */
	protected ArrayList getOutputList() {
	    
	    this.parseOutputList();
	    return this.ouputList;
	}
	
	protected ArrayList getVariableInKlammernList() {
	    
//	    this.parseOutputList();
	    return this.variableInKlammernList;
	}
	
	/**
	 * Loescht den Inhalt der ArrayList outputList.
	 */
	public static void eraseOutputList() {
	    ouputList.clear();
	}
	
	public static ArrayList getTheOuputFunctionList() {
		return ouputFunctionList;
	}
	
	public static void setTheOuputFunctionList(ArrayList newList) {
		
		ouputFunctionList = newList;
	}
	
	public static ArrayList getNichtKlammernList() {
		return nichtKlammernList;
	}
}









